-- 每日答题排行面板
Lua_EveryDayAnswerRankWindow = class("Lua_EveryDayAnswerRankWindow", Lua_ThirdSizeWindow)
function Lua_EveryDayAnswerRankWindow:ctor()
	self:superCall("ctor", true, 3500, true, LanUtil.getValue(121804));

	self.windowName = "Lua_EveryDayAnswerRankWindow";
	self.skinName = "EveryDayAnswerRankWindow_skin";
	self.w = 916;
	self.h = 574;
end

function Lua_EveryDayAnswerRankWindow:buildShowItem()
	self:superCall("buildShowItem");

	self.rankList = Lua_DragList.new(self.content, 1, Vector4(0, 0, 878, 360));
	self.rankList:setLocation(0, -24, 0);
	self.rankList:setListCell(Lua_AnswerRankItem, 72, 878, 1);

	Lua_ProxyManager.getProxy("Lua_EveryDayAnswerProxy"):sAnswerRankInfo(); 
	self:addLuaEvent("rAnswerRankInfo", self, self.onAnswerRankInfo);
end

function Lua_EveryDayAnswerRankWindow:onAnswerRankInfo(msg)
    if msg == nil then
        return;
    end

    if msg.rank_list == nil then
        return;
    end

    local arr = Array();
    for i = 1, #msg.rank_list do
        arr:add(msg.rank_list[i]);
    end
    self.rankList:setLuaArrayData(arr, false);

    local owner = msg.owner;
    if owner ~= nil then
        if owner.rank_index > 3 then
            self.myRankIcon:setEnable(false);
            self.myRankTxt.text = tostring(owner.rank_index);
        elseif owner.rank_index <= 0 then
            self.myRankIcon:setEnable(false);
            self.myRankTxt.text = "--";
        else
            self.myRankIcon:setEnable(true);
            self.myRankIcon:setAltas("leaderBoard_atlas", DataCenter.answerUtil.rankBeforeThreeUrl[owner.rank_index]);
            self.myRankTxt.text = "";
        end

        self.myNameTxt.text = DataCenter.roleData.name;
        self.myLvTxt.text = tostring(DataCenter.roleData.level);
        self.myNumTxt.text = tostring(owner.role_force);
        self.myJifenTxt.text = tostring(owner.fight_score);
        self.myTimeTxt.text = TimeTransform.getInstance():transSeconds1(owner.sex, true);
    end
end

function Lua_EveryDayAnswerRankWindow:dispose()
    if self.rankList ~= nil then
    	self.rankList:dispose()
    	self.rankList = nil;
    end

    self:superCall("dispose");
end





--------------------------------------------------





Lua_AnswerRankItem = class("Lua_AnswerRankItem", Lua_ListCell);
function Lua_AnswerRankItem:ctor(p)
	self:superCall("ctor", p, "EveryDayAnswerRankItem_skin");
end

function Lua_AnswerRankItem:buildShowItem()
	self:superCall("buildShowItem");
end

function Lua_AnswerRankItem:setData(data)
	self.data = data;

	if data.rank_index > 3 then
		self.rankIcon:setEnable(false);
		self.rankTxt.text = data.rank_index;
	elseif data.rank_index <= 0 then
		self.rankIcon:setEnable(false);
		self.rankTxt.text = "--";
	else
		self.rankIcon:setEnable(true);
		self.rankIcon:setAltas("leaderBoard_atlas", DataCenter.answerUtil.rankBeforeThreeUrl[data.rank_index]);
		self.rankTxt.text = "";
	end

	self.nameTxt.text = data.role_name;
	self.lvTxt.text = tostring(data.level);
	self.numTxt.text = tostring(data.role_force);
	self.timeTxt.text = TimeTransform.getInstance():transSeconds1(data.sex, true);
	self.jifenTxt.text = tostring(data.fight_score);
end

function Lua_AnswerRankItem:dispose()
    self:superCall("dispose");
end