-- 答题左侧栏信息面板
Lua_AnswerLeftInfoPanel = class("Lua_AnswerLeftInfoPanel", Lua_DisplayObject);
function Lua_AnswerLeftInfoPanel:ctor(p)
	self:superCall("ctor", p, "AnswerLeftInfoPanel_skin");
end

function Lua_AnswerLeftInfoPanel:buildShowItem()
	self:superCall("buildShowItem");

	self._showState = true;

	self:updateAnswerInfo();

	self.titleBg.clickScale = false;
	self.bg.clickScale = false;
	self.titleBg:addClickFuntion(self, self.onBgClick);
	self.bg:addClickFuntion(self, self.onBgClick);
	self.rankBtn:addClickFuntion(self, self.onRankBtnClick);
	self.closeBtn:addClickFuntion(self, self.onArrowBtnClick);
	self.tipsIcon:addClickFuntion(self, self.onHelp);
end

-- 更新信息
function Lua_AnswerLeftInfoPanel:updateAnswerInfo()
	self.rankTxt.text = LanUtil.formateStr(LanUtil.getValue(121806), tostring(DataCenter.answerData.ownAnswerRank));  
	self.jifenTxt.text = LanUtil.formateStr(LanUtil.getValue(121807), Lua_CommonUtil.getNumberTrans(DataCenter.answerData.ownScoreNum));  
	self.rightNumTxt.text = LanUtil.formateStr(LanUtil.getValue(121808), tostring(DataCenter.answerData.ownRightNum));  
	self.expTxt.text = LanUtil.formateStr(LanUtil.getValue(121809), Lua_CommonUtil.getNumberTrans(DataCenter.answerData.ownAnswerExp));  
	
	local num = DataCenter.answerData.ownAnswerUseTime;
	self.answerTimeTxt.text = LanUtil.formateStr(LanUtil.getValue(121810), TimeTransform.getInstance():transSeconds1(num, true));  

	num = DataCenter.answerData.answerReduiseTime - (getTime() - DataCenter.answerData.getOwnAnswerInfoTime);
	self.endTimeTxt.text = LanUtil.formateStr(LanUtil.getValue(121811), TimeTransform.getInstance():transSeconds1(num, true));  
	
	if num > 0 then
		if self.bRegisterTimer ~= true then
			self.bRegisterTimer = true;
			Lua_CommonUtil.addTimer("Lua_AnswerLeftInfoPanel", 1, self, self.updateOwnAnswerInfoTime);
		end
	end
end

function Lua_AnswerLeftInfoPanel:updateOwnAnswerInfoTime()
	local num = DataCenter.answerData.answerReduiseTime - (getTime() - DataCenter.answerData.getOwnAnswerInfoTime);
	if num <= 0 then
		num = 0;
		self:clearTimer();
	end
	self.endTimeTxt.text = LanUtil.formateStr(LanUtil.getValue(121811), TimeTransform.getInstance():transSeconds1(num, true));  
end

function Lua_AnswerLeftInfoPanel:clearTimer()
	if self.bRegisterTimer == true then
		self.bRegisterTimer = false;
		Lua_CommonUtil.removeTimer(self, self.updateOwnAnswerInfoTime);
	end
end

function Lua_AnswerLeftInfoPanel:onBgClick()
end

function Lua_AnswerLeftInfoPanel:onRankBtnClick(go)
	Lua_WindowUtil.openWin("Lua_EveryDayAnswerRankWindow", WinParam.ACTION_OPEN, nil);
end

function Lua_AnswerLeftInfoPanel:onArrowBtnClick(go)
	if self.clickTime ~= nil and getTime() - self.clickTime < 0.1 then
		OperateAlert.show(LanUtil.getValue(121419));
		return;
	end
	self.clickTime = getTime();

	self:setShowState(not self._showState);
end

function Lua_AnswerLeftInfoPanel:setShowState(val)
	self._showState = val;
	if val then
		self.closeIcon:setSacle(0.8, 0.8);
		self.closeBtn:setLocation(-386.5, 135, 0);
		self.closeIcon:setLocation(-388, 139, 0);
		self.rankBtn:setLocation(-345, 137, 0);
		TweenUtil.getInstance():addTween(self.content, 0.5, 0, Vector3(0, -2, 0), nil, nil);
	else
		self.closeBtn:setLocation(-386.5 + self.closeBtn.width + 13, 135, 0);
		self.closeIcon:setLocation(-388 - 1.5 + self.closeBtn.width + 13, 139, 0);
		self.closeIcon:setSacle(-0.8, 0.8);
		self.rankBtn:setLocation(-395, 137, 0);
		TweenUtil.getInstance():addTween(self.content, 0.5, 0, Vector3(-269, -2, 0), nil, nil);
	end
end

function Lua_AnswerLeftInfoPanel:onHelp()
	Lua_WindowUtil.openWin("Lua_RuleTipWindow", WinParam.ACTION_AUTO, LanUtil.getValue(121822));
end

function Lua_AnswerLeftInfoPanel:dispose()
	self:clearTimer();
	TweenUtil.getInstance():stop(self.content);

	self:superCall("dispose");
end