-- 答题题目
Lua_AnswerQuestionPanel = class("Lua_AnswerQuestionPanel", Lua_DisplayObject);
function Lua_AnswerQuestionPanel:ctor(p)
    self.selectState = 0;
    self.curShowIdx = 0;
    self:superCall("ctor", p, "AnswerQuestionPanel_skin");
end

function Lua_AnswerQuestionPanel:buildShowItem()
    self:superCall("buildShowItem");

    self.rightBtn:addClickFuntion(self, self.onRightBtnClick);
    self.wrongBtn:addClickFuntion(self, self.onWrongBtnClick);
    self:updateOwnSelect();
end

function Lua_AnswerQuestionPanel:onRightBtnClick(go)
	if self.selectState == 1 then
		OperateAlert.show(LanUtil.getValue(121816));
		return;
	end

	local pos = DataCenter.answerUtil:getAAreaMoveToPos();
	local rolePlayer = ThingUtil.instance:getThingById(DataCenter.roleData.roleId);
	if rolePlayer.fightControl:canJump() == false then
		OperateAlert.show(LanUtil.getValue(121821));
        return;
    end
	rolePlayer:roleJumpTo(pos, 0, -1, nil, true, 400, 1100, false);

    self.selectState = 1;
	self.rightSelect:setEnable(true);
    self.wrongSelect:setEnable(false);

	Lua_ProxyManager.getProxy("Lua_EveryDayAnswerProxy"):sAnswerJump(2);
end

function Lua_AnswerQuestionPanel:onWrongBtnClick(go)
	if self.selectState == 2 then
		OperateAlert.show(LanUtil.getValue(121816));
		return;
	end

	local pos = DataCenter.answerUtil:getBAreaMoveToPos();
	local rolePlayer = ThingUtil.instance:getThingById(DataCenter.roleData.roleId);
	if rolePlayer.fightControl:canJump() == false then
		OperateAlert.show(LanUtil.getValue(121821));
        return;
    end
	rolePlayer:roleJumpTo(pos, 0, -1, nil, true, 400, 1100, false);

    self.selectState = 2;
	self.rightSelect:setEnable(false);
    self.wrongSelect:setEnable(true);

	Lua_ProxyManager.getProxy("Lua_EveryDayAnswerProxy"):sAnswerJump(1);
end

-- 展示题目
function Lua_AnswerQuestionPanel:updateShowQuestion()
	if self.curShowIdx ~= DataCenter.answerData.questionIndex then
		self:setScale(0.01, 0.01);
		TweenUtil.getInstance():addTween(self.content, 0.2, 0, nil, nil, Vector3(1, 1, 1));
	end
	self.curShowIdx = DataCenter.answerData.questionIndex;

	self.numTxt.text = LanUtil.formateStr(LanUtil.getValue(121813), tostring(self.curShowIdx)); 
	self.questionTxt.text = DataCenter.answerData.questionDesc;

	local num = Mathf.Round(DataCenter.answerData.questionReduiseTime - (getTime() - DataCenter.answerData.questionGetTime));
	if num > 0 then
		self.reduiseTime = num;
		self.timeTxt.text = num.."s";
		if self.bRegistTime == nil or self.bRegistTime == false then
			self.bRegistTime = true;
			Lua_CommonUtil.addTimer("updateAnswerQuestionTime", 1, self, self.updateAnswerQuestionTime, nil, -1);
		end
	else
		self:clearTimer();
		self.timeTxt.text = "";
	end
end

function Lua_AnswerQuestionPanel:updateAnswerQuestionTime()
	self.reduiseTime = self.reduiseTime - 1;
	if self.reduiseTime > 0 then
		self.timeTxt.text = self.reduiseTime.."s";
	else
		self:clearTimer();
		self.timeTxt.text = "";
	end
end

function Lua_AnswerQuestionPanel:clearTimer()
	if self.bRegistTime ~= nil and self.bRegistTime == true then
        self.bRegistTime = false;
        Lua_CommonUtil.removeTimer(self, self.updateAnswerQuestionTime);
    end
end

-- 更新判断自己选择的对错
function Lua_AnswerQuestionPanel:updateOwnSelect()
	local pos = DataCenter.hook:getCurPos();
	if pos ~= nil then
		if DataCenter.answerUtil:checkPosInAArea(pos) == true then
			self.rightSelect:setEnable(true);
		    self.wrongSelect:setEnable(false);
		    self.selectState = 1;
		elseif DataCenter.answerUtil:checkPosInBArea(pos) == true then
			self.rightSelect:setEnable(false);
		    self.wrongSelect:setEnable(true);
		    self.selectState = 2;
		else
			self.rightSelect:setEnable(false);
		    self.wrongSelect:setEnable(false);
		    self.selectState = 0;
		end
	else
		self.rightSelect:setEnable(false);
	    self.wrongSelect:setEnable(false);
	    self.selectState = 0;
	end
end

function Lua_AnswerQuestionPanel:dispose()
	self:clearTimer();
	self.curShowIdx = 0;
	TweenUtil.getInstance():stop(self.content);

    self:superCall("dispose");
end